
//Räknar längden på en sträng, exklusive avslutande nollan
int strlength(char *s) {
    int i = 0;
    while (*s) {
        i++;
        s++;
    }
    return i;
}

//Reverserar strängen s in place. Returnerar argumentet. 
char *reverse(char *s) {
    int len = strlength(s);
    char *start = s;
    //end ska peka på sista tecknet (alltså inte avslutande nollan.)
    char *end = s + (len - 1);
    char temp;
    //Byt plats på tecken i början och tecken i slutet av strängen
    //tills s "går förbi" end
    while (end > s) {
        temp = *end;
        *end = *s;
        *s = temp;
        end--;
        s++;
    }
    return start;
}

//Letar upp en substräng (subs) i en söksträng (s) och returnerar
//en pekare till den första platsen där substrängen uppträder
//i söksträngen. Returnerar 0 om ingen sådan plats hittas. 
//Detta är en "naiv" algoritm. För mer effektiva alternativ är
//wikipedia-sidan en bra startpunkt: 
//https://en.wikipedia.org/wiki/String_searching_algorithm
char *substr(char *s, char *subs) {
    int i = 0;
    int len = strlength(subs);
    int flag;
    int len2 = strlength(s);
    //Vi säger att en tom substräng finns först i söksträngen.
    if (len == 0) {
        return s;
    }    
    //Om substrängen är längre än söksträngen
    if (len > len2) {
        return 0;
    }    
    
    //Undersök varje möjlig startpunkt i strängen s för att se om där finns
    //en kopia av subs. Avbryt loopen när subst inte längre kan få plats.
    while (*(s + (len -1))) {
        flag = 1;
        for(i = 0; i < len; i++) {
            //Så fort ett tecken inte matchar, bryt for-loopen
            if (*(s + i) != *(subs + i)) {
                flag = 0;
                break;
            }
        }
        
        if (flag) {
            return s;
        }
        //i nästa iteration, undersök nästa startpunkt i s
        s++;
    }
    return 0;
}